package oracle.jrockit.jfr.tools;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.Arrays;

/** @deprecated */
@Deprecated
public final class ConCatRepository {

   private File repositoryDirectory;
   private File outFile;
   private boolean forceOverwrite = false;


   public static void usage() {
      System.out.println("Usage: ");
      System.out.println(ConCatRepository.class.getSimpleName() + " JFR Repository directory [-o <outfile>]");
      System.out.println("optional -o: output filename");
      System.out.println("optional -f: force file overwrite");
   }

   public static void main(String[] var0) throws Exception {
      ConCatRepository var1 = new ConCatRepository();
      var1.loadFiles(var0);
   }

   public void loadFiles(String[] var1) throws IOException, FileNotFoundException {
      if(var1.length == 0) {
         this.repositoryDirectory = new File(".");
      } else if(!this.parseArgs(var1)) {
         return;
      }

      if(!this.repositoryDirectory.exists()) {
         usage();
         throw new FileNotFoundException("Could not find jfr repository " + this.repositoryDirectory);
      } else {
         FilenameFilter var2 = new FilenameFilter() {
            public boolean accept(File var1, String var2) {
               return var2.endsWith(".jfr");
            }
         };
         String[] var3 = this.repositoryDirectory.list(var2);
         if(0 == var3.length) {
            usage();
            throw new FileNotFoundException("Could not find any incomplete flight recordings in the specified directory");
         } else {
            Arrays.sort(var3);
            if(null == this.outFile) {
               this.outFile = new File(var3[0].substring(0, var3[0].indexOf(".")) + "-" + var3[var3.length - 1].substring(0, var3[var3.length - 1].indexOf(".")) + ".jfr");
            }

            if(this.outFile.exists() && !this.forceOverwrite) {
               throw new IOException("The specified file already exists " + this.outFile + "." + " Use -f to force override");
            } else {
               BufferedOutputStream var4 = new BufferedOutputStream(new FileOutputStream(this.outFile), 4096);

               try {
                  String[] var5 = var3;
                  int var6 = var3.length;

                  for(int var7 = 0; var7 < var6; ++var7) {
                     String var8 = var5[var7];
                     BufferedInputStream var9 = new BufferedInputStream(new FileInputStream(new File(this.repositoryDirectory + "/" + var8)), 4096);
                     byte[] var10 = new byte[4096];

                     int var11;
                     while((var11 = var9.read(var10)) > 0) {
                        var4.write(var10, 0, var11);
                     }

                     var9.close();
                  }
               } finally {
                  var4.flush();
                  var4.close();
               }

            }
         }
      }
   }

   boolean parseArgs(String[] var1) {
      int var2 = 0;
      if(!var1[0].startsWith("-")) {
         this.repositoryDirectory = new File(var1[0]);
         ++var2;
      } else {
         this.repositoryDirectory = new File(".");
      }

      try {
         while(var2 < var1.length) {
            char var3 = var1[var2].charAt(1);
            switch(var3) {
            case 102:
               this.forceOverwrite = true;
               ++var2;
               break;
            case 111:
               this.outFile = new File(var1[var2 + 1]);
               var2 += 2;
               break;
            default:
               System.err.println("Unknown flag: " + var3);
               usage();
               return false;
            }
         }
      } catch (ArrayIndexOutOfBoundsException var4) {
         System.out.println("To few arguments:");
         usage();
      }

      return true;
   }
}
